//AC130-Script by LurchiDerLurch ac130_init

private ["_pos","_dialog"];

_pos = _this select 0;

//functions
KeyEvents = 
{
	private["_type","_params","_handled", "_ctrl", "_dikCode", "_shift", "_ctrlKey", "_alt"];
	
	_params = _this select 0;
	_type = _this select 1;
  	_ctrl = _params select 0;
 	_dikCode = _params select 1;
 	_shift = _params select 2;
 	_ctrlKey = _params select 3;
 	_alt = _params select 4;
 
 	switch (_type) do
	{
		case "down":
		{
			if (_dikCode == 17) then
			{
				//W pressed
				if (cam_rotating_radius > 500) then
				{
					cam_rotating_radius = cam_rotating_radius - 1;
				};
			};
			
			if (_dikCode == 30) then
			{
				//A pressed
				if (cam_rotating_deg >= 0.05) then
				{
					cam_rotating_deg = cam_rotating_deg - 0.001;
				};
			};
			
			if (_dikCode == 31) then
			{
				//S pressed
				cam_rotating_radius = cam_rotating_radius + 1;
			};
			
			if (_dikCode == 32) then
			{
				//D pressed
				if (cam_rotating_deg < 0.3) then
				{
					cam_rotating_deg = cam_rotating_deg + 0.001;
				};
			};
			
			if (_dikCode == 33) then
			{
				//F pressed
				[-2]call switchWeapon
			};
			
			if (_dikCode == 35) then
			{
				//H pressed
				[]spawn showHelp;
			};
			
			if (_dikCode == 45) then
			{
				//X pressed
				if(showFlir) then
				{
					showFlir = false;
					[inversion,false]call createEffect;
					((finddisplay  1000) displayctrl 1008) ctrlSetText "Flir off";
				}
				else
				{
					showFlir = true;
					[inversion,true]call createEffect;
					((finddisplay  1000) displayctrl 1008) ctrlSetText "Flir on";
				};
			};
			
			if (_dikCode == 46) then
			{
				//C pressed
				[]call changeView;
			};
			
			if (_dikCode == 49) then
			{
				//N pressed
				[]call enableNVG;
			};
			
			if (_dikCode == 18) then
			{
				//E pressed
				if (showBlink) then 
				{
					showBlink = false;
					((finddisplay  1000) displayctrl 1008) ctrlSetText "Show Blink Signal off";
				}
				else
				{
					showBlink = true;
					((finddisplay  1000) displayctrl 1008) ctrlSetText "Show Blink Signal on";
				};
			};
			
			if (_dikCode == 16) then
			{
				//Q pressed
				if (showTroops) then 
				{
					showTroops = false;
					((finddisplay  1000) displayctrl 1008) ctrlSetText "Show Troops off";
				}
				else
				{
					showTroops = true;
					((finddisplay  1000) displayctrl 1008) ctrlSetText "Show Troops on";
				};
			};
			
			if (_dikCode == 2) then
			{
				//1 pressed
				[0]call switchWeapon
			};
			
			if (_dikCode == 3) then
			{
				//2 pressed
				[1]call switchWeapon
			};
			
			if (_dikCode == 4) then
			{
				//3 pressed
				[2]call switchWeapon
			};
			
			pressedKey = [_dikCode,_ctrl,_shift,_ctrlKey,_alt];
		};
		
		case "up":
		{	
			pressedKey = [-1,false,false,false,false];
		};
	};
	 

};

MouseEvents =
{
	private["_param","_type","_x","_y","_check1","_check2","_type","_button","_shift","_wheel","_zoom","_inversion"];
	
	_param = _this select 1;
	_type = _this select 0;
	_x = 0;
	_y = 0;
	_check1 = true;
	_check2 = true;
	
	switch (_type) do 
	{
		case "MouseMoving": 
		{
			_x = ((_param select 1)-0.5);
			_y = ((_param select 2)-0.5)*-1;
			
			//if (_x > 0.5 || _x < -0.5 || _y > 0.5 || _y < -0.5) then {_check1 = false;};	
			
			//if (_x > 0.35 || _x < -0.35 || _y > 0.35 || _y < -0.35) then {_check2 = false;};	
			
			mousePosition = [_x,_y,_check1,_check2];						
		};
		case "MouseButtonDown": 
		{
			_button = _param select 1;
			_shift = _param select 4;
			mouseButtons set[_button, true];
			mouseButtons set[4, _shift];
		};	
		case "MouseButtonUp": 
		{
			_button = _param select 1;
			mouseButtons set[_button, false];
		};	
		case "MouseZChanged": 
		{
			_wheel = _param select 1;
			mouseWheel = _wheel;
			if (!(pressedKey select 0 == 42)) then
			{
				//Zoom
				camFov = camFov - _wheel/50;
				if (camFov > 1.0) then {camFov = 1.0};
				if (camFov < 0.05) then {camFov = 0.05};
				_zoom = ceil(11 - camFov*10);
				((finddisplay  1000) displayctrl 1008) ctrlSetText format ["Zoom: %1x",_zoom]; 
			}
			else
			{
				//Flir
				inversion = inversion - _wheel/50;
				if (inversion > 1.0) then {inversion = 1.0};
				if (inversion < 0.1) then {inversion = 0.1};
				_inversion = inversion*10;
				((finddisplay  1000) displayctrl 1008) ctrlSetText format ["Contrast: %1",_inversion]; 
				if(showFlir) then {[inversion,true]call createEffect};	
			};
		};	
	};	
};

createCam =
{
	private ["_cam"];
	
	_cam = "camera" camcreate [0, 0, 0];
	_cam cameraeffect ["internal", "back"];
	_cam camSetFov camFov;
	_cam setDir 0;
	
	showCinemaBorder false;
	camUseNVG false;

	_cam camSetTarget cam_rotating_center;
	_cam camCommit 0;
	
	[0.1,true]call createEffect;
	
	if(useNVG) then
	{
		camUseNVG true;
	};
	
      _cam;
};

enableNVG = 
{
	switch(typeNVG) do
	{
		case 0:
		{
			//green
			if(useNVG) then
			{
				camUseNVG false;
				useNVG = false;
			}
			else
			{
				camUseNVG true;
				useNVG = true;
			};
		};
		case 1:
		{
			//grey
			camUseNVG false;
			if(useNVG) then
			{
				useNVG = false;
				setaperture -1;
			}
			else
			{
				useNVG = true;
				_daytime = round daytime;
				switch (_daytime) do 
				{
					case 0:{setaperture 0.05;};
					case 1:{setaperture 0.1};
					case 2:{setaperture 0.1;};
					case 3:{setaperture 0.1;};
					case 4:{setaperture 0.1;};
					case 5:{setaperture 0.1;};
					case 6:{setaperture 1.0;};
					case 7:{setaperture 4.0;};
					case 8:{setaperture 12.0;};
					case 9:{setaperture 23.0;};
					case 15:{setaperture 25.0;};
					case 16:{setaperture 14.0;};
					case 17:{setaperture 4.0;};
					case 18:{setaperture 1.0;};
					case 19:{setaperture 0.03;};
					case 20:{setaperture 0.03;};
					case 21:{setaperture 0.03;};
					case 22:{setaperture 0.03;};
					case 23:{setaperture 0.05;};
					case 24:{setaperture 0.05;};
					default {setaperture 35.0;};
				};
			};

		};
	};
};

createEffect =
{
	private ["_inversion","_daytime"];
	
	_inversion = _this select 0;
	_flir = _this select 1;
	
	ppEffectDestroy ppccor;
      ppEffectDestroy ppcinv;
      ppEffectDestroy ppfilm;
      ppEffectDestroy ppdyblur;
      setAperture -1; 
      
      if(_flir) then
      {
		ppccor = ppEffectCreate ["ColorCorrections", 1];
	      ppccor ppEffectEnable true;
	      ppccor ppEffectAdjust [1, 1, -0.002, [1, 1, 1, 0.1], [1, 1, 1, 0], [1, 1, 1, 0]];
	      ppccor ppEffectCommit 0;

	      ppcinv = ppEffectCreate ["colorInversion", 2];
	      ppcinv ppEffectEnable true;
	      ppcinv ppEffectAdjust [_inversion,_inversion,_inversion]; //[0.1,0.1,0.1]
	      ppcinv ppEffectCommit 0;
	      
	      ppfilm = ppEffectCreate ["filmGrain", 3];
	      ppfilm ppEffectEnable true;
	      ppfilm ppEffectAdjust [0.1, 1, 1, 0.1, 1, false];
	      ppfilm ppEffectCommit 0;

	      ppdyblur = ppEffectCreate ["dynamicBlur", 0];
	      ppdyblur ppEffectEnable true;  
	      ppdyblur ppEffectAdjust [0.4];
	      ppdyblur ppEffectCommit 0;
	      
	      _daytime = round daytime;
		switch (_daytime) do 
		{
			case 0:{setaperture 0.05;};
			case 1:{setaperture 0.1};
			case 2:{setaperture 0.1;};
			case 3:{setaperture 0.1;};
			case 4:{setaperture 0.1;};
			case 5:{setaperture 0.1;};
			case 6:{setaperture 1.0;};
			case 7:{setaperture 4.0;};
			case 8:{setaperture 12.0;};
			case 9:{setaperture 23.0;};
			case 15:{setaperture 25.0;};
			case 16:{setaperture 14.0;};
			case 17:{setaperture 4.0;};
			case 18:{setaperture 1.0;};
			case 19:{setaperture 0.03;};
			case 20:{setaperture 0.03;};
			case 21:{setaperture 0.03;};
			case 22:{setaperture 0.03;};
			case 23:{setaperture 0.05;};
			case 24:{setaperture 0.05;};
			default {setaperture 35.0;};
		};
	};
};

changeView = 
{
	if (viewMode == 1) then
	{
		viewMode = 0;
		//interior
		switch (equippedWeapon) do
		{
			case 0:
			{
				((finddisplay  1000) displayctrl 1007) ctrlSetText "Bilder\Vis25mm.paa"; 
				((finddisplay  1000) displayctrl 1007) ctrlSetPosition [SafeZoneX + SafeZoneW/2 - SafeZoneW/8,SafeZoneY + SafeZoneH/2 - SafeZoneH/8,SafeZoneW/4,SafeZoneH/4];
				((finddisplay  1000) displayctrl 1007) ctrlCommit 0;
				((finddisplay  1000) displayctrl 1004) ctrlSetText "25mm Gatling Gun"; 
				((finddisplay  1000) displayctrl 1004) ctrlCommit 0;
			};
			case 1:
			{
				((finddisplay  1000) displayctrl 1007) ctrlSetText "Bilder\visier02.paa"; 
				((finddisplay  1000) displayctrl 1007) ctrlSetPosition [SafeZoneX + SafeZoneW/2 - SafeZoneW/8,SafeZoneY + SafeZoneH/2 - SafeZoneH/8,SafeZoneW/4,SafeZoneH/4];
				((finddisplay  1000) displayctrl 1007) ctrlCommit 0;
				((finddisplay  1000) displayctrl 1004) ctrlSetText "Bofors 40mm"; 
				((finddisplay  1000) displayctrl 1004) ctrlCommit 0;
			};
			case 2:
			{
				((finddisplay  1000) displayctrl 1007) ctrlSetText "Bilder\visier03.paa"; 
				((finddisplay  1000) displayctrl 1007) ctrlSetPosition [SafeZoneX + SafeZoneW/2 - SafeZoneW/8,SafeZoneY + SafeZoneH/2 - SafeZoneH/8,SafeZoneW/4,SafeZoneH/4];
				((finddisplay  1000) displayctrl 1007) ctrlCommit 0;
				((finddisplay  1000) displayctrl 1004) ctrlSetText "105mm Howitzer"; 
				((finddisplay  1000) displayctrl 1004) ctrlCommit 0;
			};
		};
	}
	else
	{
		viewMode = 1;
		//exterior				
		((finddisplay  1000) displayctrl 1007) ctrlSetText "Bilder\VisExt.paa"; 
		((finddisplay  1000) displayctrl 1007) ctrlSetPosition [SafeZoneX + SafeZoneW/2 - SafeZoneW/32,SafeZoneY + SafeZoneH/2 - SafeZoneH/32,SafeZoneW/16,SafeZoneH/16];
		((finddisplay  1000) displayctrl 1007) ctrlCommit 0;
	}; 	
};

setTargetPosition =
{
	private["_dirv","_dirh","_pos","_r_sphere","_z","_r","_x","_y"];
	
	_dirv = _this select 0; //vertical direction
	_dirh = _this select 1; //horizontal direction
	_r_sphere = _this select 2;
	
	//calculate altitude realative to the vertical direction
	
	_z = _r_sphere* cos(90 - _dirv);	
	
	// calculate little radius relative to the altitude

	_r = sqrt(_r_sphere^2 - _z^2);

	// calculate x/y relative to the new circle

	_x = sin(_dirh)*_r;
	_y = cos(_dirh)*_r;
	
	_pos = getPosASL ac130_cam;

	targetCam setPosASL [(_pos select 0)+_x,(_pos select 1)+_y,(_pos select 2)+_z];
};

setCirclePosition = 
{
	private["_angle","_center","_height","_object"];
	
	_angle = _this select 0;
	_center = _this select 1;
	_height = _this select 2;
	_object = _this select 3;
	
	if(heightASL) then
	{
		_object setPosASL [(getPos _center select 0)+sin(_angle)*cam_rotating_radius,(getPos _center select 1)+cos(_angle)*cam_rotating_radius, _height]; //above sea level
	}
	else
	{
		_object setPos [(getPos _center select 0)+sin(_angle)*cam_rotating_radius,(getPos _center select 1)+cos(_angle)*cam_rotating_radius, _height]; //above ground
	};
};

getObjectAngles = 
{
	private["_obj1","_obj2","_x1","_x2","_y1","_y2","_angH","_c","_a","_b","_q","_p","_h","_angV"];
	
	_obj1 = _this select 0;
	_obj2 = _this select 1;
	
	_x1 = getPos _obj1 select 0;
	_x2 = getPos _obj2 select 0;
	_y1 = getPos _obj1 select 1;
	_y2 = getPos _obj2 select 1;
	
	_angH = (_x2-_x1) atan2 (_y2-_y1);
	
	_c = _obj1 distance _obj2;
	_a = (getPosASL _obj1 select 2) - (getPosASL _obj2 select 2);
	_b = sqrt(_c^2 - _a^2);
	_q = _a^2/_c;
	_p = _c - _q;
	_h = sqrt(_p*_q);
	_angV = atan(_h/_p);
	if(_a > 0) then
	{
		_angV = 360 - _angV;
	};	
	
	[_angH,_angV];
};

normalizeAngle = 
{
	private["_angle"];
	
	_angle = _this select 0;
	if (_angle > 360) then {_angle = _angle - 360;};
	if (_angle < 0) then {_angle = 360 + _angle;};
	_angle; 
};

switchWeapon = 
{
	private["_weapon"];
	
	_weapon = _this select 0;
	
	if (_weapon < 0) then
	{
		
		if (equippedWeapon + 1 >= 3) then
		{
			equippedWeapon = 0;
		}
		else
		{
			equippedWeapon = equippedWeapon + 1;
		};
	}
	else
	{
		equippedWeapon = _weapon;
	};
	
	((finddisplay  1000) displayctrl 1007) ctrlSetTextColor [1,1,1,1];
	
	if (viewMode == 0) then
	{
		switch (equippedWeapon) do
		{
			case 0:
			{
				((finddisplay  1000) displayctrl 1007) ctrlSetText "Bilder\Vis25mm.paa"; 
				((finddisplay  1000) displayctrl 1007) ctrlSetPosition [SafeZoneX + SafeZoneW/2 - SafeZoneW/8,SafeZoneY + SafeZoneH/2 - SafeZoneH/8,SafeZoneW/4,SafeZoneH/4];
				((finddisplay  1000) displayctrl 1007) ctrlCommit 0;
			};
			case 1:
			{
				((finddisplay  1000) displayctrl 1007) ctrlSetText "Bilder\visier02.paa"; 
				((finddisplay  1000) displayctrl 1007) ctrlSetPosition [SafeZoneX + SafeZoneW/2 - SafeZoneW/8,SafeZoneY + SafeZoneH/2 - SafeZoneH/8,SafeZoneW/4,SafeZoneH/4];
				((finddisplay  1000) displayctrl 1007) ctrlCommit 0;
			};
			case 2:
			{
				((finddisplay  1000) displayctrl 1007) ctrlSetText "Bilder\visier03.paa"; 
				((finddisplay  1000) displayctrl 1007) ctrlSetPosition [SafeZoneX + SafeZoneW/2 - SafeZoneW/8,SafeZoneY + SafeZoneH/2 - SafeZoneH/8,SafeZoneW/4,SafeZoneH/4];
				((finddisplay  1000) displayctrl 1007) ctrlCommit 0;
			};
		};
	};
	
	switch (equippedWeapon) do
	{
		case 0:
		{
			((finddisplay  1000) displayctrl 1004) ctrlSetText "25mm Gatling Gun"; 
			((finddisplay  1000) displayctrl 1004) ctrlCommit 0;
		};
		case 1:
		{
			((finddisplay  1000) displayctrl 1004) ctrlSetText "Bofors 40mm"; 
			((finddisplay  1000) displayctrl 1004) ctrlCommit 0;
		};
		case 2:
		{
			((finddisplay  1000) displayctrl 1004) ctrlSetText "105mm Howitzer"; 
			((finddisplay  1000) displayctrl 1004) ctrlCommit 0;
		};
	};
};

calculateBullet = 
{
	private["_dirh","_dirv","_weapon","_pos","_look","_r_sphere","_z","_r","_x","_y","_color","_size","_glowSize","_vel","_weight","_volume","_drag","_shell","_fromObj","_toObj"];
	
	_dirh = _this select 0;
	_dirv = _this select 1;
	_weapon = _this select 2;
	_pos = _this select 3;
	
	_look =  screenToWorld [0.5,0.5];
	
	_r_sphere = 100;
	_z = _r_sphere* cos(_dirv - 90);	
	_r = sqrt(_r_sphere^2 - _z^2);
	_x = sin(_dirh)*_r;
	_y = cos(_dirh)*_r;

	switch (_weapon) do
	{
		case 0:
		{
			if(muni25 > 0) then
			{
				muni25 = muni25 - 1;
				playSound "gun01";
				_color = [[1,0.1,0.1,1],[0.5,0.5,0.5,1],[0.5,0.5,0.5,1]];
				_size = [1];
				_glowSize = [(1*3)/5];
				_vel = [_x*100,_y*100,_z*100];
				_weight = 80.0;
				_volume = 0.005;
				_rubbing = 0.001;
				_shell = "B_30x113mm_M789_HEDP" createvehicle _pos;
				_shell setPos [_pos select 0,_pos select 1,_pos select 2];
				_shell setVelocity _vel;
				
				//drop["\Ca\Data\kouleSvetlo", "", "Billboard", 1, 4,_pos, _vel, 0, _weight, _volume, _rubbing, _size, _color, [0, 1], 0, 0, "", "",""];
				_light = "#particlesource" createVehicleLocal getPos _shell;
				_light setParticleParams ["\Ca\Data\kouleSvetlo", "", "Billboard", 1, 0.01, [0,0,0], [0,0,0], 0, _weight, _volume, _rubbing, _size, _color, [0, 1], 0, 0, "", "", _shell];
				_light setDropInterval 0.01;
				
				_smoketrail = "#particlesource" createVehicleLocal getPos _shell;
				_smoketrail setParticleParams ["\ca\data\missileSmoke","","Billboard",100,0.5,[0,0,0],[0,0,0],0,0.6,0.5,0.05,[1,2.5,3,3.5],[[1,1,1,0.05],[1,1,1,0.05],[0,0,0,0]],[0],0,0,"","",_shell];				
				_smoketrail setDropInterval 0.002;
			}
			else
			{
				ac130_loadmaster sideChat "AC130-Loadmaster: Out of ammo!";
			};
		};
		
		case 1:
		{
			if(muni40 > 0) then
			{
				muni40 = muni40 - 1;
				playSound "gun02";
				_color = [[1,0.1,0.1,1],[0.5,0.5,0.5,1],[0.5,0.5,0.5,1]];
				_size = [1*2];
				_glowSize = [(1*3)/5];
				_vel = [_x*50,_y*50,_z*50];
				_weight = 80.0;
				_volume = 0.005;
				_rubbing = 0.001;
				_shell = "Sh_125_HE" createvehicle _pos;
				_shell setPos [_pos select 0,_pos select 1,_pos select 2];
				_shell setVelocity _vel;
				
				//drop["\Ca\Data\kouleSvetlo", "", "Billboard", 1, 4, _pos, _vel, 0, _weight, _volume, _drag, _size, _color, [0, 1], 0, 0, "", "", ""];
				
				_light = "#particlesource" createVehicleLocal getPos _shell;
				_light setParticleParams ["\Ca\Data\kouleSvetlo", "", "Billboard", 1, 0.002, [0,0,0], [0,0,0], 0, _weight, _volume, _rubbing, _size, _color, [0, 1], 0, 0, "", "", _shell];
				_light setDropInterval 0.002;
				_smoketrail = "#particlesource" createVehicleLocal getPos _shell;
				_smoketrail setParticleParams ["\ca\data\missileSmoke","","Billboard",100,0.5,[0,0,0],[0,0,0],0,0.6,0.5,0.05,[1,2.5,3,3.5],[[1,1,1,0.05],[1,1,1,0.05],[0,0,0,0]],[0],0,0,"","",_shell];				
				_smoketrail setDropInterval 0.002;
			}
			else
			{
				ac130_loadmaster sideChat "AC130-Loadmaster: Out of ammo!";
			};
		};
		
		case 2:
		{
			if(muni105 > 0) then
			{
				muni105 = muni105 - 1;
				playSound "gun03";
				_color = [[1,0.1,0.1,1],[0.5,0.5,0.5,1],[0.5,0.5,0.5,1]];
				_size = [1*2];
				_glowSize = [(1*3)/5];
				_vel = [_x*50,_y*50,_z*50];
				_weight = 80.0;
				_volume = 0.005;
				_rubbing = 0.001;
				//Bo_GBU12_LGB
				_shell = "B_30x113mm_M789_HEDP" createvehicle _pos;
				_shell setPos [_pos select 0,_pos select 1,_pos select 2];
				_shell setVelocity _vel;
				
				//drop["\Ca\Data\kouleSvetlo", "", "Billboard", 1, 4, _pos, _vel, 0, _weight, _volume, _drag, _size, _color, [0, 1], 0, 0, "", "", ""];
				_light = "#particlesource" createVehicleLocal getPos _shell;
				_light setParticleParams ["\Ca\Data\kouleSvetlo", "", "Billboard", 1, 0.002, [0,0,0], [0,0,0], 0, _weight, _volume, _rubbing, _size, _color, [0, 1], 0, 0, "", "", _shell];
				_light setDropInterval 0.002;
				_smoketrail = "#particlesource" createVehicleLocal getPos _shell;
				_smoketrail setParticleParams ["\ca\data\missileSmoke","","Billboard",100,0.5,[0,0,0],[0,0,0],0,0.6,0.5,0.05,[1,2.5,3,3.5],[[1,1,1,0.05],[1,1,1,0.05],[0,0,0,0]],[0],0,0,"","",_shell];				
				_smoketrail setDropInterval 0.002;

				waitUntil{(!alive _shell)};
				_shell = "Bo_Mk82" createvehicle _look;
				_shell setPos [_look select 0,_look select 1,0];
			}
			else
			{
				ac130_loadmaster sideChat "AC130-Loadmaster: Out of ammo!";
			};
		};
	};
};

showHelp = 
{
	titleText [format 
	["
	Move your Mouse to aim\n
	LEFT MOUSE: Fire\n
	MOUSE WHEEL: Zoom\n
	MOUSE WHEEL + SHIFT: Contrast\n
	1 2 3 or F: Change Weapons\n
	Q: Enable/disable showing vehicles on Hud\n
	E: Enable/disable showing signal for friendly units\n
	X: Enable/disable FLIR\n
	N: Enable/disable night vision googles\n
	C: Change view\n
	ESC: Abort\n
	"], "BLACK OUT",2];
	
	{
		((finddisplay  1000) displayctrl _x) ctrlShow false;
	}forEach [1004,1005,1006,1007,1020,1008,1009,1012,1013,1014,1015,1016,1017,1018,1019,1021];
	
	sleep 4;
	titleFadeOut 1;
	
	{
		((finddisplay  1000) displayctrl _x) ctrlShow true;
	}forEach [1004,1005,1006,1007,1020,1008,1009,1012,1013,1014,1015,1016,1017,1018,1019,1021];
};

//variables
setMousePosition [0.5,0.5];
cam_rotating_center = "HeliHEmpty" createVehicle [_pos select 0,_pos select 1,0];
cam_rotating_center2 = "HeliHEmpty" createVehicle [_pos select 0,_pos select 1,0];
targetCam = "HeliHEmpty" createVehicle getpos cam_rotating_center; // target which camera is always looking at
gunPosition = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0, 0, 0], [], 0, ""];
mouseButtons = [false,false,false,false,false];
mousePosition = [0,0,false,false];
mouseWheel = 1;
shooting0 = false;
shooting1 = false;
shooting2 = false;
pressedKey = [-1,false,false,false,false];
equippedWeapon = 0;
mouseShift = false;
cameraMoving = false;
laserTarget = false;
guns_enabled = false;
inversion = _this select 9;
camFov = 1.0;
showBlink = _this select 6;
showTroops = _this select 7;
showFlir = _this select 8;
viewMode = 0;
cam_rotating_angle = 0; // start angle for rotating NOT looking
cam_rotating_radius = _this select 1; // radius to center for rotating NOT looking
cam_rotating_height = _this select 2; // height of camera for rotating NOT looking
cam_rotating_dirh = 0; // direction of camera, but without mouse direction
cam_rotating_deg = 0.1; // speed for rotating
cam_dirh = 180;
cam_dirv = 300;
guns_dirh = 180;
guns_dirv = 300;
muni25 = _this select 3;
muni40 = _this select 4;
muni105 = _this select 5;
heightASL = _this select 10;
view360 = _this select 11;
showSmoketrails = _this select 12;
useNVG  = _this select 13;
typeNVG  = _this select 14;

ac130_plane = "C130J" createVehicle getPos player;
_ac130_pilot = "USMC_Soldier_Pilot" createUnit [getPos player,createGroup WEST,"ac130_pilot = this; this moveInDriver ac130_plane; this allowDamage false", 0.6, "corporal"];
_ac130_copilot = "USMC_Soldier_Pilot" createUnit [getPos player,group ac130_pilot,"ac130_copilot = this; this moveInCargo ac130_plane; this allowDamage false", 0.6, "corporal"];
_ac130_loadmaster = "USMC_Soldier_Pilot" createUnit [getPos player,group ac130_pilot,"ac130_loadmaster = this; this moveInCargo ac130_plane; this allowDamage false", 0.6, "corporal"];
ac130_plane allowDamage false;
ac130_plane engineOn true;
ac130_plane setFuel 1;

//smoketrails
_smoketrail1 = "#particlesource" createVehicleLocal (ac130_plane modelToWorld [10,0,-1]);
_smoketrail1 setParticleParams ["\ca\data\missileSmoke","","Billboard",100,4,[10,0,-1],[0,0,0],0,0.6,0.5,0.05,[1,2.5,3,3.5],[[0.7,0.7,0.7,0.05],[0.7,0.7,0.7,0.05],[0,0,0,0]],[0],0,0,"","",ac130_plane];				
_smoketrail1 setDropInterval 0.01;

_smoketrail2 = "#particlesource" createVehicleLocal (ac130_plane modelToWorld [5,0,-1]);
_smoketrail2 setParticleParams ["\ca\data\missileSmoke","","Billboard",100,4,[5,0,-1],[0,0,0],0,0.6,0.5,0.05,[1,2.5,3,3.5],[[0.7,0.7,0.7,0.05],[0.7,0.7,0.7,0.05],[0,0,0,0]],[0],0,0,"","",ac130_plane];				
_smoketrail2 setDropInterval 0.01;

_smoketrail3 = "#particlesource" createVehicleLocal (ac130_plane modelToWorld [-5,0,-1]);
_smoketrail3 setParticleParams ["\ca\data\missileSmoke","","Billboard",100,4,[-5,0,-1],[0,0,0],0,0.6,0.5,0.05,[1,2.5,3,3.5],[[0.7,0.7,0.7,0.05],[0.7,0.7,0.7,0.05],[0,0,0,0]],[0],0,0,"","",ac130_plane];				
_smoketrail3 setDropInterval 0.01;

_smoketrail4 = "#particlesource" createVehicleLocal (ac130_plane modelToWorld [-10,0,-1]);
_smoketrail4 setParticleParams ["\ca\data\missileSmoke","","Billboard",100,4,[-10,0,-1],[0,0,0],0,0.6,0.5,0.05,[1,2.5,3,3.5],[[0.7,0.7,0.7,0.05],[0.7,0.7,0.7,0.05],[0,0,0,0]],[0],0,0,"","",ac130_plane];				
_smoketrail4 setDropInterval 0.01;

ac130_invisibleModel = "HeliHEmpty" createVehicle getpos cam_rotating_center;
ac130_invisibleModel2 = "HeliHEmpty" createVehicle getpos cam_rotating_center2;

//Create the dialog
_dialog = createDialog "AC130Dialog";

//Create the cam
ac130_cam = []call createCam;

//Start all scripts
[]spawn ac130_main;
[]spawn ac130_main_moving;
[]spawn ac130_blink;
[]spawn ac130_troops;
[]spawn ac130_sound;
[]spawn ac130_display_lines;

//Let all scripts know that the init is done
ac130_initComplete = true;

