//AC130-Script by LurchiDerLurch ac130_main

private ["_screen","_xM","_yM","_structured","_infos","_difh","_difv","_muni25","_muni40","_muni105","_360View","_angles","_logic","_plane"];

waitUntil {(ac130_initComplete)};

_screen = [];
_muni25 = muni25;
_muni40 = muni40;
_muni105 = muni105;
_360View = view360;
_logic = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0, 0, 0], [], 0, ""];

while {dialog} do
{
	sleep 0.001;
	
	//Compass
	for [{_i = 0;_j = 0},{_i < 360;_j < 4},{_i = _i + 90;_j = _j + 1}] do 
	{
		_x = (0.5- 0.035 + sin(_i - cam_dirh)*(SafeZoneW/4 - SafeZoneW/100));
		_y = (0.5- 0.025 - cos(_i - cam_dirh)*(SafeZoneH/4 - SafeZoneH/100));
		
		(finddisplay 1000 displayCtrl 1012+_j) ctrlSetPosition [_x,_y];
		(finddisplay 1000 displayCtrl 1012+_j) ctrlCommit 0;
	};
	
	//Diference indicator  
	_x = (SafeZoneX + SafeZoneW/2 - SafeZoneW/200)+sin(_difh)*SafeZoneW/16;
	_y = (SafeZoneY + SafeZoneH - SafeZoneH/4);
	
	(finddisplay 1000 displayCtrl 1016) ctrlSetPosition [_x,_y];
	(finddisplay 1000 displayCtrl 1016) ctrlCommit 0;
	(finddisplay 1000 displayCtrl 1017) ctrlSetPosition [_x,_y];
	(finddisplay 1000 displayCtrl 1017) ctrlCommit 0;
	
	_x = (SafeZoneX + SafeZoneW - SafeZoneW/4);
	_y = (SafeZoneY + SafeZoneH/2)+sin(_difv)*SafeZoneH/16;
	
	(finddisplay 1000 displayCtrl 1018) ctrlSetPosition [_x,_y];
	(finddisplay 1000 displayCtrl 1018) ctrlCommit 0;
	(finddisplay 1000 displayCtrl 1019) ctrlSetPosition [_x,_y];
	(finddisplay 1000 displayCtrl 1019) ctrlCommit 0;
	
	//Looking
	_xM = mousePosition select 0;
	_yM = mousePosition select 1;
	_difh = [(cam_dirh + _xM*2 - cam_rotating_angle)]call normalizeAngle;
	_difv = [cam_dirv + _yM*2 - 180]call normalizeAngle;

	if(viewMode == 0) then
	{
		//interior
		
		((finddisplay  1000) displayctrl 1007) ctrlSetTextColor [1,1,1,1];
		guns_enabled = true;
	
		//horizontal
		if((!(_difh < 90) && !(_difh > 270)) || _360View) then
		{
			cam_dirh = cam_dirh + _xM*2;
		}
		else
		{
			if(_difh < 90) then
			{
				cam_dirh = [cam_rotating_angle + 90]call normalizeAngle;
			}
			else
			{
				cam_dirh = [cam_rotating_angle - 90]call normalizeAngle;
			};
		};
		
		//vertical
		if(!(_difv < 100) && !(_difv > 190)) then
		{
			cam_dirv = cam_dirv + _yM*2;
		}
		else
		{
			if(_difv > 100) then
			{
				cam_dirv = 10;
			}
			else
			{
				cam_dirv = 280;
			};
		};
		
		cam_dirv = [cam_dirv]call normalizeAngle;
		cam_dirh = [cam_dirh]call normalizeAngle;
	
		[cam_dirv,cam_dirh,50]call setTargetPosition;
	}
	else
	{
		//exterior
		targetCam setPos (ac130_plane modelToWorld [-30,0,0]);
		gunPosition setPos (ac130_plane modelToWorld [-5,0,-5]); //gun
		_logic setPos (screenToWorld [0.5,0.5]);
		_angles = [gunPosition,_logic]call getObjectAngles;
		guns_dirh = _angles select 0;
		guns_dirv = _angles select 1;
		guns_dirv = [guns_dirv]call normalizeAngle;
		guns_dirh = [guns_dirh]call normalizeAngle;
		
		//vertical
		if(!(_difv < 90) && !(_difv > 190)) then
		{
			cam_dirv = cam_dirv + _yM*2;
		}
		else
		{
			if(_difv > 100) then
			{
				cam_dirv = 10;
			}
			else
			{
				cam_dirv = 270;
			};
		};
		
		//horizontal
		cam_dirh = cam_dirh + _xM*2;
		
		cam_dirv = [cam_dirv]call normalizeAngle;
		cam_dirh = [cam_dirh]call normalizeAngle;
		
		//guns
		_difh = [(guns_dirh - cam_rotating_angle)]call normalizeAngle;
		_difv = [guns_dirv - 180]call normalizeAngle;
		
		if(_difh > 90 && _difh < 270 && _difv > 100 && _difv < 190) then
		{
			((finddisplay  1000) displayctrl 1007) ctrlSetTextColor [1,1,1,1];
			guns_enabled = true;
		}
		else
		{
			((finddisplay  1000) displayctrl 1007) ctrlSetTextColor [1,1,1,0];
			guns_enabled = false;
		};
	};
		
	ac130_cam camSetTarget targetCam;
	ac130_cam camSetFov camFov;
	ac130_cam camCommit 0;
	
	if(viewMode == 0) then 
	{
		_plane = ac130_cam;
	}
	else
	{
		_plane = ac130_plane;
	};
	
	//Info Display Left
	_structured = composeText [""];
	_infos = 
	[
		//format ["V: %1  H: %2",round(cam_dirv),round(cam_dirh)],
		format ["V: %1  H: %2 \\ %3",cam_dirv,cam_dirh,_difh],
		format ["Alt: %1m (%2 ASL)",getPos _plane select 2,getPosASL _plane select 2]
	];
	{
		_structured = composeText [_structured,_x,lineBreak];

	} forEach _infos;
	((finddisplay  1000) displayctrl 1005) ctrlSetStructuredText _structured;
				
	//Info Display Right
	_structured = composeText [""];
	_infos = 
	[
		format ["25mm: %1/%2",muni25,_muni25],
		format ["40mm: %1/%2",muni40,_muni40],
		format ["105mm: %1/%2",muni105,_muni105]
	];
	{
		_structured = composeText [_structured,_x,lineBreak];

	} forEach _infos;
	((finddisplay  1000) displayctrl 1020) ctrlSetStructuredText _structured;
	
	//Range
	((finddisplay  1000) displayctrl 1009) ctrlSetText format ["Range: %1",round(ac130_cam distance (screenToWorld [0.5,0.5]))];
		
	//Center Circle
	_screen = worldToScreen getPos cam_rotating_center;
	
      if (count _screen != 2) then
     	{                              
      	_screen = [-1,-1];
     	};
     
	(finddisplay 1000 displayCtrl 1006) ctrlSetPosition [(_screen select 0)-0.05,(_screen select 1)-0.07];
	(finddisplay 1000 displayCtrl 1006) ctrlCommit 0;
		
	//Laser
	//TODO: Lasertarget
	if (mouseButtons select 1 && !laserTarget) then 
	{
		laserTarget = true;
	};

	//Shooting
	if (mouseButtons select 0 && !(mouseButtons select 4) && mousePosition select 3) then 
	{
		[]spawn
		{
			private ["_pos","_dirh","_dirv","_angles"];
			if(viewMode == 0) then
			{
				_pos = getPos ac130_cam;
				_dirh = cam_dirh;
				_dirv = cam_dirv;
			}
			else
			{
				_pos = getPos gunPosition;
				_dirh = guns_dirh;
				_dirv = guns_dirv;
			};		
			
			if(!guns_enabled && viewMode == 1)exitWith{};
			
			switch (equippedWeapon) do
			{
				case 0:
				{
					if (!shooting0) then
					{
						//25mm
						shooting0 = true;
						[_dirh,_dirv,0,_pos]spawn calculateBullet;
						//sleep 0.125;
						sleep 0.075;
						shooting0 = false;
					};
				};
				
				case 1:
				{
					if (!shooting1) then
					{	
						shooting1 = true;					
						//40mm
						[_dirh,_dirv,1,_pos]spawn calculateBullet;
						sleep 0.5;
						shooting1 = false;	
					};
					
				};
				
				case 2:
				{	
					if (!shooting2) then
					{
						shooting2 = true;					
						//105mm
						[_dirh,_dirv,2,_pos]spawn calculateBullet;
						sleep 1.5;
						playSound "reload";
						sleep 2;
						ac130_loadmaster sideChat "AC130-Loadmaster: Gun ready!";
						shooting2 = false;	
					};
				};
			};
		};	
	};
};

camDestroy ac130_cam;
setaperture -1;
ac130_cam cameraeffect ["terminate", "back"];
ac130_initComplete = false;

{
	deleteVehicle _x;
}forEach [ac130_plane,ac130_pilot,ac130_copilot,ac130_loadmaster];

ppEffectDestroy ppccor;
ppEffectDestroy ppcinv;
ppEffectDestroy ppfilm;
ppEffectDestroy ppdyblur;

